% Optimization of the shape of a Tubular Bell to specific frequenc
% @ Vipul Kakkad 2/2/2012

% targets = column vector of target rations f2/f1, f3/f1, f4/f1, etc.
% Mcoeffs = number of coefficients used.
% N = number of collocation points

% targets = [2.75653849405069
%           5.40391760938276
%            8.9329503138518];

% targets = [2.92308606249322
%           5.62073257619242
%           9.25952878366399];

fval = 0;

targets = [4;7;10];

N = 40;

Mcoeffs = 3;
Results = zeros(5,Mcoeffs);
% objective function
objective = @(x)target_func(x,targets,N);
% objective = @(x)target_func([x(1);x(2);x(3);x(4);x(5)],targets,N);

% options for the optimization
optvar = optimset('MaxIter',300,'TolFun',1e-15,'TolX',1e-15,'MaxFunEvals',10000);
% for ind = 1:5
    while(fval > -9)
    % initial ratios
    % Coeffs_0 = 0.1*ones(Mcoeffs,1);
    Coeffs_0 = rand(Mcoeffs,1);
    
    % Optimization finding the minimum error over the coefficient space
%     [Coeffs_out,fval,exitflag,output] = fminunc(objective,Coeffs_0,optvar)
    [Coeffs_out,fval,exitflag,output] = fminsearch(objective,Coeffs_0,optvar);
    end

    optvar = optimset('MaxIter',1000,'TolFun',1e-15,'TolX',1e-15,'MaxFunEvals',10000);
% optvar = optimset('Display','iter','MaxIter',1000,'TolFun',1e-15,'TolX',1e-15,'MaxFunEvals',10000);
    [Coeffs_out,fval,exitflag,output] = fminsearch(objective,Coeffs_0,optvar);

%     Results(ind,1:Mcoeffs)=Coeffs_out;   
    Coeffs_out
% end

% Results
   % Radius of the final shape
    rad_out = coeffs2logR_Gaussian(N,Coeffs_out,0);
    [eigenvals] = free_free_nonuniform(40, rad_out, numel(targets)+1, 0);
    rad_out = coeffs2logR_Gaussian(N,Coeffs_out,1);


%Calculate and display targets and achieved
v2 = eigenvals / eigenvals(1);
v2 = v2.^2;
disp('Target, Achieved, and Error:');
disp([targets v2(2:end) targets - v2(2:end)])


